<template>
	<div class="product-form" :class="{'product-form--styled': is_styled}">
		<template v-for="p in product.packages">
			<div class="product-form__package" :key="p.id" v-show="p.id == active_package">
				<div class="product-form__package__title">{{ p.title }}</div>
				<div class="product-form__package__text">{{ p.text }}</div>
				<div class="product-form__package__price" :class="{'product-form__package__price--sale': form.promocode}">{{ finalPrice | currency }}</div>
				<div class="product-form__package__help">После бронирования стоимость курса для вас не изменится</div>
			</div>
		</template>
		<div class="product-form__sale" v-if="form.promocode">Скидка {{ finalSale | currency }} по промокоду <strong>{{ form.promocode.code }}</strong></div>

		<form class="product-form__form">
			<div class="product-form__input">
				<label>Имя</label>
				<input type="text" v-model="form.name" placeholder="Иван" name="name" autocomplete="name">
			</div>
			<div class="product-form__input">
				<label>Email</label>
				<div class="input__error" v-if="errors.email">{{ errors.email }}</div>
				<input type="email" v-model="form.email" placeholder="name@domain.ru" name="email" autocomplete="email">
			</div>
			<div class="product-form__input product-form__input--messenger">
				<label>Мессенджер для связи</label>
				<input type="text" v-model="form.messenger_value" :placeholder="messengers[form.messenger].placeholder" autocomplete="off">
				<div class="product-form__input--messenger__select">
					<template v-for="(m, key) in messengers">
						<i class="icon-m" :class="m.icon" :style="{color: m.color}" :key="`i-${key}`" v-if="key == form.messenger"></i>
					</template>
					<i class="ri-arrow-drop-down-line"></i>
					<select v-model="form.messenger">
						<option v-for="(m, key) in messengers" :key="key" :value="key">{{ m.name }}</option>
					</select>
				</div>
			</div>
			<div class="product-form__input product-form__input--promocode" v-if="promocodes" :class="{'product-form__input--promocode--loading': promocode_loading, 'product-form__input--promocode--success': form.promocode}">
				<label>Промокод (если есть)</label>
				<div class="input__error" v-if="errors.promocode">{{ errors.promocode }}</div>
				<input type="text" placeholder="Promo" v-model.lazy="promocode_test" v-debounce="500">
				<i class="ri-checkbox-circle-fill" v-if="form.promocode"></i>
			</div>
			<div class="product-form__input product-form__input--button">
				<button class="button button--primary" :class="{'button--loading': form_loading}" :disabled="!is_valid" @click.prevent="submit">Перейти к оплате</button>
			</div>
		</form>

		<div class="product-form__disclaimer">
			<i class="ri-information-line"></i>
			Заполняя и отправляя данную форму, вы даёте своё согласие на обработку персональных данных и получение электронных писем.
		</div>
	</div>
</template>

<script>
import debounce from "v-debounce";
import validate from "~/plugins/validate";

import {get as _get, keyBy as _keyBy, find as _find} from "lodash";

export default {
	directives: {debounce},

	props: {
		product_id: {
			required: true
		},
		package_id: {

		},
		styled: {
			type: Boolean
		},
		success_url: {
			default: null
		},
		promocodes: {
			default: true
		}
	},

	watch: {
		package_id(v) {
			this.active_package = v;
		},

		promocode_test(code) {
			this.$set(this.errors, 'promocode', null);
			this.$set(this.form, 'promocode', null);

			if (code.length) {
				this.promocode_loading = true;

				this.$axios.get(this.api_host + `/api/product/${this.product.id}/promocode/${code.toUpperCase().trim()}`).then(r => {
					this.promocode = r.data;
					this.update_promocode_in_form();
				}).catch(e => {
					this.$set(this.errors, 'promocode', 'Промокод не найден');
				}).then(() => {
					this.promocode_loading = false;
				});
			}
		},

		active_package(id) {
			this.update_promocode_in_form();
		}
	},

	filters: {
		currency(value) {
			return (new Intl.NumberFormat('ru-RU', { style: 'decimal'}).format(parseFloat(value)) + ' руб.');
		}
	},

	data() {
		return {
			api_host: 'https://s.va-promotion.ru',

			product: {},
			is_styled: this.styled === false ? false : true,

			active_package: null,
			// active_package: this.package_id || null

			promocode_test: null,
			promocode_loading: false,
			promocode: null,
			errors: {

			},
			form_loading: false,
			form: {
				messenger: 'tg',
				messenger_value: null,
				promocode: null,
				name: null,
				email: null,
				partner: null
			},

			messengers: {
				wa: {
					name: 'WhatsApp',
					icon: 'ri-whatsapp-fill',
					color: '#128c7e',
					placeholder: 'Номер телефона'
				},
				fb: {
					name: 'Facebook Messenger',
					icon: 'ri-messenger-fill',
					color: '#0084ff',
					placeholder: 'Ссылка на профиль'
				},
				tg: {
					name: 'Telegram',
					icon: 'ri-telegram-fill',
					color: '#0088cc',
					placeholder: 'Номер телефона или аккаунт'
				},
				sk: {
					name: 'Skype',
					icon: 'ri-skype-fill',
					color: '#00aff0',
					placeholder: 'Аккаунт или ссылка на профиль'
				},
				vk: {
					name: 'ВКонтакте',
					icon: 'icon-vk',
					color: '#45668e',
					placeholder: 'Ссылка на профиль'
				}
			}
		}
	},

	created() {
		this.load();
	},

	computed: {
		finalPrice() {
			return this.calculate_promocode(_get(this, `product.packages.package-${this.active_package}.price`));
		},
		finalSale() {
			return _get(this, `product.packages.package-${this.active_package}.price`) - this.finalPrice;
		},
		is_valid() {
			return validate.email(this.form.email) && this.form.messenger_value;
		},
		promocode_plans() {
			return _get(this.promocode, 'plans', []);
		}
	},

	mounted() {
		this.addRemixicons();
	},

	methods: {
		addRemixicons() {
			var link = document.createElement( "link" );
			link.href = "https://cdn.jsdelivr.net/npm/remixicon@2.5.0/fonts/remixicon.css";
			link.type = "text/css";
			link.rel = "stylesheet";

			document.getElementsByTagName( "head" )[0].appendChild( link );
		},

		update_promocode_in_form() {
			if (this.promocode_plans.length) {
				if (this.promocode_plans.indexOf(this.active_package) != -1) {
					this.$set(this.form, 'promocode', this.promocode);
					this.$set(this.errors, 'promocode', null);
				} else {
					this.$set(this.form, 'promocode', null);
					this.$set(this.errors, 'promocode', 'Не работает с этим тарифом');
				}
			} else {
				this.$set(this.form, 'promocode', this.promocode);
			}
		},

		load() {
			this.$axios.get(this.api_host + '/api/product/' + this.product_id).then(r => {
				r.data.packages = _keyBy(r.data.packages, (item) => {
					return 'package-' + item.id;
				});
				this.active_package = _find(r.data.packages, 'id').id;
				this.product = r.data;

				var url_promo = new URL(window.location.href).searchParams.get("promo");
				if (url_promo) {
					this.promocode_test = url_promo;
				}
			});
		},

		submit() {
			this.form_loading = true;

			// Track Facebook
			if (typeof window.fbq != "undefined") {
				window.fbq('track', 'InitiateCheckout', {currency: "RUB", value: this.finalPrice});
			}

			this.$axios.post(this.api_host + '/api/order', {
				total         	: this.finalPrice,
				carrotquest_id	: _get(window, 'carrotquest.data.user.id', null),
				info          	: {
					promocode	: this.form.promocode,
					sale		: this.finalSale
				},
				customer		: {
					name			: this.form.name,
					email			: this.form.email,
					messenger		: this.form.messenger,
					messenger_value	: this.form.messenger_value
				},
				success_url		: this.success_url,
				package_id    	: this.active_package
			}).then(r => {
				let redirect = _get(r, 'data.redirect');
				if (redirect) {

					//Track Yandex.Metrika success submit
					if (window.ym) {
						ym(40157550, 'reachGoal', 'submit_form_success', {
							order_price: this.finalPrice,
							currency: "RUB"
						});
					}

					window.location.href = redirect;
				}
			}).catch(e => {
				this.form_loading = false;
				console.log(e.response);
			});
		},

		calculate_promocode(price) {
			if (!this.form.promocode) {
				return price;
			} else {

				let p = this.form.promocode;
				switch (p.type) {
					case 'fixed':
						return price - p.value;
						break;

					case 'percent':
						return (price * (100 - p.value) / 100).toFixed(0);
						break;

					default:
						return price;
						break;
				}

			}
		}
	}
}
</script>


<style lang="scss">
.product-form {
	&--styled {
		background-color: white;
		border: 1px solid rgba($primary, .1);
		padding: 50px;
		border-radius: 8px;
	}
	&__package {
		font-size: 0px;
		&__title {
			font-weight: 700;
			font-size: 24px;
			line-height: (30 / 24);
		}
		&__text {
			font-size: 14px;
			line-height: 1.5;
			opacity: 0.8;
			margin-top: 8px;
			margin-bottom: 20px;
		}
		&__price {
			font-weight: bold;
			font-size: 30px;
			line-height: 1;
			display: inline-block;
			vertical-align: top;
			&--sale {
				color: #59A836;
			}
		}
		&__help {
			display: inline-block;
			font-size: 12px;
			line-height: (16 / 12);
			opacity: 0.8;
			width: 230px;
			margin: 0px 0px 0px 20px;
			vertical-align: top;
			@include sm {
				width: 100%;
				display: block;
				margin-top: 8px;
				margin-left: 0;
			}
		}
	}

	&__sale {
		font-size: 12px;
		line-height: (16 / 12);
		opacity: 0.8;
		margin-top: 12px;
	}

	&__form {
		display: flex;
		flex-wrap: wrap;
		margin-right: -15px;
		margin-left: -15px;
		margin-left: -8px;
		margin-right: -8px;
		margin-top: 35px;
		padding-top: 15px;
		border-top: 1px solid rgba(0, 0, 0, 0.1);
	}

	&__input {
		flex: 0 0 50%;
		max-width: 50%;
		padding-left: 8px;
		padding-right: 8px;
		margin-top: 20px;
		position: relative;

		@include xs {
			flex: 0 0 100%;
			max-width: 100%;
		}

		label {
			display: block;
			font-size: 12px;
			line-height: 1;
			opacity: 0.65;
			margin-bottom: 5px;
		}

		input[type="text"],
		input[type="email"] {
			font-family: inherit;
			display: block;
			border-radius: 4px;
			background: #fff;
			border: 1px solid rgba(39, 122, 195, 0.35);
			padding: 16px 25px;
			width: 100%;
			font-size: 14px;
			box-shadow: none;
			appearance: none;
			&:focus {
				border-color: $primary;
			}
		}

		&--promocode {
			input[type="text"] {
				text-transform: uppercase;
			}
			position: relative;
			&--loading {
				&:after {
					content: " ";
					width: 16px;
					height: 16px;
					position: absolute;
					border-radius: 50%;
					border: 2px solid rgba($primary, .3);
					border-top-color: $primary;
					animation: spin 1s linear infinite;
					right: 25px;
					bottom: 18px;
				}
			}

			&--success {
				input[type="text"],
				input[type="text"]:focus {
					border-color: #59A836;
				}
				.ri-checkbox-circle-fill {
					color: #59A836;
					position: absolute;
					right: 25px;
					bottom: 18px;
				}
			}
		}

		.input__error {
			position: absolute;
			bottom: -6px;
			right: 15px;
			font-size: 12px;
			color: #dc1a1a;
			background-color: white;
			padding: 0px 5px;
			z-index: 10;
			~ input[type="text"],
			~ input[type="email"] {
				border-color: #dc1a1a;
				z-index: 5;
			}
		}

		&--messenger {
			flex: 0 0 100%;
			max-width: 100%;
			position: relative;
			input[type="text"] {
				padding-left: 70px;
				z-index: 5;
			}
			&__select {
				position: absolute;
				z-index: 10;
				left: 30px;
				bottom: 11px;
				cursor: pointer;
				i {
					display: inline-block;
				}
				.icon-m {
					font-size: 20px;
					&.icon-vk {
						border-radius: 50%;
						width: 20px;
						height: 20px;
						background-color: rgb(69, 102, 142);
						display: inline-block;
						vertical-align: top;
						&:after {
							content: "V";
							font-weight: 900;
							font-family: "arial black", arial, sans-serif;
							color: white;
							font-style: normal;
							line-height: 20px;
							display: block;
							text-align: center;
							font-size: 10px;
						}
					}
				}
				.ri-arrow-drop-down-line {
					font-size: 20px;
					margin: 0px 0px 0px -4px;
				}
				select {
					position: absolute;
					top: 0;
					left: 0;
					width: 100%;
					height: 100%;
					appearance: none;
					opacity: 0;
					cursor: pointer;
				}
			}
		}

		&--button {
			padding-top: 19px;
			@include xs {
				padding-top: 0;
			}
			.button {
				width: 100%;
				line-height: 1;
				padding: 16px 15px;
				height: auto;
				line-height: 1.4;
				letter-spacing: 0.02em;
    			font-size: 12px;
				@include xs {
					font-size: 11px;
				}
			}
		}



	}
	&__disclaimer {
		font-size: 12px;
		line-height: 1.5;
		opacity: 0.5;
		padding-left: 25px;
		margin-top: 24px;
		position: relative;

		i {
			position: absolute;
			left: 0;
			top: -2px;
			font-size: 16px;
		}
	}
}
</style>
